// Crack sounds
datablock AudioProfile(superCrackSound1)
{
   filename    = "./supersonic_snap1.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(superCrackSound2)
{
   filename    = "./supersonic_snap2.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(subCrackSound1)
{
   filename    = "./subsonic1.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(subCrackSound2)
{
   filename    = "./subsonic2.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(fastRicoSound1)
{
   filename    = "./ric1.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(fastRicoSound2)
{
   filename    = "./ric2.wav";
   description = AudioDefault3d;
   preload = true;
};


if(	$Pref::Suppression::Vignette $= "")
	$Pref::Suppression::Vignette = true;
if(	$Pref::Suppression::VignetteColor $= "")
	$Pref::Suppression::VignetteColor = "1 0 0";

if(	$Pref::Suppression::Whiteout $= "")
	$Pref::Suppression::Whiteout = true;
if(	$Pref::Suppression::WhiteoutIntensity $= "")
	$Pref::Suppression::WhiteoutIntensity = 0.25;
	
if(	$Pref::Suppression::IgnoresWalls $= "")
	$Pref::Suppression::IgnoresWalls = false;

	
function suppressionCheckWalls(%start, %end)
{
	// init raycast
	%mask = $TypeMasks::FxBrickObjectType;
	%raycast = containerRayCast(%start, %end, %mask);
	%hit = getWord(%raycast, 0);
	
	//if(isObject(%hit))
	//drawLine(%start, %end, "1 0 0 0.2", 0.2);
	//else
	//drawLine(%start, %end, "0 1 0 0.2", 0.2);
	
	return %hit;
}
	
function doSuperSonicCrackFX(%startPoint, %endPoint, %sourcePlayer, %data, %hit, %hitPosition)
{
	%vector = vectorSub(%endPoint, %startPoint);
	
	if(%hit)%vector = vectorSub(%hitPosition, %startPoint);	// round was cut short by an impact, adjust length of vector to accomodate
	
	%length = vectorLen(%vector);
	
	if(%hit)%length++;	// adjust length up slightly so that players who get shot still see surpression effects
	
	%supressionDistance = %data.suppressionRadius;
	
	for (%i = 0; %i < ClientGroup.getCount(); %i++) 
	{
		if(isObject(%player = (%client = ClientGroup.getObject(%i)).player)) 
		{
			if(%player == %sourcePlayer)
				continue;
				
			%playerPosition = %player.getPosition();
				
			%vN = vectorNormalize(%vector);
			%v2 = vectorSub(%playerPosition, %startPoint);
			%dot = vectorDot(%vN, vectorNormalize(%v2));
			
			%closestPoint = vectorAdd(%startPoint, vectorScale(%vN, %dot * vectorLen(%v2)));
			%angle = mACos(%dot);
			%deg = mRadtoDeg(%angle);
			
			if(vectorDist(%startPoint, %closestPoint) < %length && vectorDist(%playerPosition, %closestPoint) < %supressionDistance)
			{
				if(%deg < 90)
				{
					// Bullet has near-missed this player
					// Supersonic FX
					if(%data.isSuperSonic)
						%client.play3D("superCrackSound" @ getRandom(1, 2), %closestPoint);
					else
						%client.play3D("subCrackSound" @ getRandom(1, 2), %closestPoint);
					
					// Suppression
					if(%data.isSuppressive)
					{
					
						%blockedByWall = !(
						!isObject(suppressionCheckWalls(%playerPosition, %closestPoint)) || 			// can our feet see the round
						!isObject(suppressionCheckWalls(%player.getHackPosition(), %closestPoint)) || 	// can our chest see the round
						!isObject(suppressionCheckWalls(%player.getEyePoint(), %closestPoint))			// can our head see the round
						);
					
						if(!%blockedByWall || $Pref::Suppression::IgnoresWalls)
						{
							%mag = mClampF((%supressionDistance - vectorLen(vectorSub(%closestPoint, %player.getHackPosition()))) / %supressionDistance, 0, 1);
							%player.onSuppressed(%mag); // this function can be packaged for custom functionality
							
							if($Pref::Suppression::Vignette || $Pref::Suppression::Whiteout)
							{
								// Whiteout Suppression
								if($Pref::Suppression::Whiteout)
								{
									%player.setWhiteOut(%mag * $Pref::Suppression::WhiteoutIntensity);
								}
								
								// Vignette Suppression
								if($Pref::Suppression::Vignette)
								{
									if(isObject(%client = %player.client))
									{
										if(%mag > %client.highestVigSupression)
										{
											commandToClient(%client, 'setVignette', 0, $Pref::Suppression::VignetteColor SPC %mag);
											%client.fadeOutSurpressionVignette(%mag);
											%client.highestVigSupression = %mag;
										}
										else
										{
											%client.fadeOutSurpressionVignette(%client.highestVigSupression);
										}
									}
								}
							}
						}
					}
					//drawLine(%closestPoint, %player.getPosition(), "1 0 1 0.2", "0.2");
					//drawLine(%startPoint, %player.getPosition(), "0 1 0 0.2", "0.2");
				}
			}
		}
	}
	return;
}


// this function was written by Port, editted for this purpose
function gameConnection::fadeOutSurpressionVignette( %this, %value )
{
	cancel(%this.fadeOutSurpressionVignette);

	if(%value < 0)
	{
		commandToClient( %this, 'SetVignette', $EnvGuiServer::VignetteMultiply, $EnvGuiServer::VignetteColor );
		return;
	}

	commandToClient(%this, 'SetVignette', 0, $Pref::Suppression::VignetteColor SPC %value);
	%this.fadeOutSurpressionVignette = %this.schedule(50, "fadeOutSurpressionVignette", %value - 0.02);
	%this.highestVigSupression = %value;
}

// Package this function if you want to use custom suppression effects
function Player::onSuppressed(%player, %mag)
{
	return;
}